# List Comprehension

L1 = [x*2 for x in range(1, 11)]

L2 = [x*2 for x in range(1, 11) if x*2 >= 12]

# List Comp to find List Length

def length(xs):
   return sum([? for _ in xs])

# List Comprehension Continued

def rep(x, n):
    return ?

def even(x):
    return x%2==0

def odd(x):
    return not(even(x))

def boomBangs(xs):
   return ?

Lbb = boomBangs(range(1,21))

# List Comprehension With Two Lists
nouns = ["hobo", "frog", "pope"]
adjectives = ["lazy", "grouchy", "scheming"]
L3 = ?

# Remove non UpperCase

def removeNonUpperCase(st):
   upCase = [chr(i) for i in range(ord('A'), ord('Z')+1)]
   return ?

# Nested List Comprehension

xxs = [[1,3,5,2,3,1,2,4,5],[1,2,3,4,5,6,7,8,9],[1,2,4,2,1,6,3,1,3,2,3,6]]

L4 = ?

def add3(x):
    return x + 3

L5 = map(add3, [1, 5, 3, 1, 6])

L6 = map(lambda x: x+3, [1, 5, 3, 1, 6])

L7 = map(?)

# Partial Functions

from functools import partial

def power(base, exponent):
    return base ** exponent

square = partial(power, exponent=2)
cube = partial(power, exponent=3)

# Partial Functions Example

def rep(x, n):
    return [x for i in range(n)]

def repit(xs):
    rep3 = ?
    return map(rep3, xs)

# Another Example with Map

def sqr(x):
    return x*x

def mapSqr?

map (mapSqr, [[1,2], [3, 4, 5, 6], [7, 8]])

# Filter

def grt3(x):
    return x>3

L8 = filter(grt3, [1,5,3,2,1,6,4,3,2,1])
L9 = filter(lambda x: x==3, [1,5,3,2,1,6,4,3,2,1])
L10 = filter(?)

# Reduce

reduce(?)

reduce(?)

